export declare type Uint128 = string;
export declare type Address = string;
export declare type TokenType = CustomToken | NativeToken;
export declare type Decimal = string;
/**
 * Base64 encoded
 */
export declare type ViewingKey = string;
export declare class TokenPair {
    readonly token_0: TokenType;
    readonly token_1: TokenType;
    constructor(token_0: TokenType, token_1: TokenType);
}
export declare class TokenPairAmount {
    readonly pair: TokenPair;
    readonly amount_0: Uint128;
    readonly amount_1: Uint128;
    constructor(pair: TokenPair, amount_0: Uint128, amount_1: Uint128);
}
export declare class TokenTypeAmount {
    readonly token: TokenType;
    readonly amount: Uint128;
    constructor(token: TokenType, amount: Uint128);
}
export interface CustomToken {
    custom_token: {
        contract_addr: Address;
        token_code_hash: string;
    };
}
export interface NativeToken {
    native_token: {
        denom: string;
    };
}
export interface Coin {
    readonly denom: string;
    readonly amount: string;
}
export interface Fee {
    readonly amount: ReadonlyArray<Coin>;
    readonly gas: Uint128;
}
export declare function create_coin(amount: Uint128): Coin;
export declare function create_fee(amount: Uint128, gas?: Uint128 | undefined): Fee;
export declare function create_base64_msg(msg: object): string;
export declare function add_native_balance_pair(amount: TokenPairAmount): Coin[] | undefined;
export declare function add_native_balance(amount: TokenTypeAmount): Coin[] | undefined;
export declare enum TypeOfToken {
    Native = 0,
    Custom = 1
}
export declare function get_token_type(token: TokenType): TypeOfToken;
export declare class ContractInfo {
    readonly code_hash: string;
    readonly address: Address;
    constructor(code_hash: string, address: Address);
}
export declare class ContractInstantiationInfo {
    readonly code_hash: string;
    readonly id: number;
    constructor(code_hash: string, id: number);
}
