"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContractInstantiationInfo = exports.ContractInfo = exports.get_token_type = exports.TypeOfToken = exports.add_native_balance = exports.add_native_balance_pair = exports.create_base64_msg = exports.create_fee = exports.create_coin = exports.TokenTypeAmount = exports.TokenPairAmount = exports.TokenPair = void 0;
const base64_1 = require("@waiting/base64");
class TokenPair {
    constructor(token_0, token_1) {
        this.token_0 = token_0;
        this.token_1 = token_1;
    }
}
exports.TokenPair = TokenPair;
class TokenPairAmount {
    constructor(pair, amount_0, amount_1) {
        this.pair = pair;
        this.amount_0 = amount_0;
        this.amount_1 = amount_1;
    }
}
exports.TokenPairAmount = TokenPairAmount;
class TokenTypeAmount {
    constructor(token, amount) {
        this.token = token;
        this.amount = amount;
    }
}
exports.TokenTypeAmount = TokenTypeAmount;
function create_coin(amount) {
    return {
        denom: 'uscrt',
        amount
    };
}
exports.create_coin = create_coin;
function create_fee(amount, gas) {
    if (gas === undefined) {
        gas = amount;
    }
    return {
        amount: [{ amount, denom: "uscrt" }],
        gas,
    };
}
exports.create_fee = create_fee;
function create_base64_msg(msg) {
    return base64_1.b64encode(JSON.stringify(msg));
}
exports.create_base64_msg = create_base64_msg;
function add_native_balance_pair(amount) {
    let result = [];
    if (get_token_type(amount.pair.token_0) == TypeOfToken.Native) {
        result.push(create_coin(amount.amount_0));
    }
    else if (get_token_type(amount.pair.token_1) == TypeOfToken.Native) {
        result.push(create_coin(amount.amount_1));
    }
    else {
        result = undefined;
    }
    return result;
}
exports.add_native_balance_pair = add_native_balance_pair;
function add_native_balance(amount) {
    let result = [];
    if (get_token_type(amount.token) == TypeOfToken.Native) {
        result.push(create_coin(amount.amount));
    }
    else {
        result = undefined;
    }
    return result;
}
exports.add_native_balance = add_native_balance;
var TypeOfToken;
(function (TypeOfToken) {
    TypeOfToken[TypeOfToken["Native"] = 0] = "Native";
    TypeOfToken[TypeOfToken["Custom"] = 1] = "Custom";
})(TypeOfToken = exports.TypeOfToken || (exports.TypeOfToken = {}));
function get_token_type(token) {
    const raw = token;
    if (raw.hasOwnProperty('native_token')) {
        return TypeOfToken.Native;
    }
    return TypeOfToken.Custom;
}
exports.get_token_type = get_token_type;
class ContractInfo {
    constructor(code_hash, address) {
        this.code_hash = code_hash;
        this.address = address;
    }
}
exports.ContractInfo = ContractInfo;
class ContractInstantiationInfo {
    constructor(code_hash, id) {
        this.code_hash = code_hash;
        this.id = id;
    }
}
exports.ContractInstantiationInfo = ContractInstantiationInfo;
